/* sf15r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__15 = 15;

real sf15r_c(real *x, integer *l, integer *ierr)
{
    /* Initialized data */

    static real zero = 0.f;
    static real onep = 1.f;
    static real sys059 = 3.4e38f;
    static real sys051 = 1.192093e-7f;
    static real a[10] = { 1.494662e-4f,.002468503f,.008638442f,.01077064f,
            .007820404f,.007595093f,.0115696f,.02183181f,.05680519f,.4431472f 
            };
    static real b[10] = { 3.18592e-5f,9.898333e-4f,.006432147f,.01680402f,
            .02614501f,.03347894f,.04271789f,.05859366f,.09375f,.25f };

    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    double log(doublereal);

    /* Local variables */
    static real suma, sumb;
    static integer i__;
    static real caysq;
    extern /* Subroutine */ int utsf10_c(integer *, integer *);
    static real eta, cay;

    *ierr = 0;
    caysq = *x;
    if (*l < 1 || *l > 3) {
        goto L10;
    }
    switch (*l) {
        case 1:  goto L1;
        case 2:  goto L6;
        case 3:  goto L7;
    }
L1:
    if (caysq < zero) {
        goto L8;
    }
    eta = onep - caysq;
L2:
    if (eta < zero) {
        goto L9;
    }
L3:
    if (eta < sys051) {
        goto L5;
    }
    suma = zero;
    sumb = zero;
    for (i__ = 1; i__ <= 10; ++i__) {
        suma = (suma + a[i__ - 1]) * eta;
        sumb = (sumb + b[i__ - 1]) * eta;
/* L4: */
    }
    ret_val = suma - (real)log(eta) * sumb;
    ret_val += onep;
    goto L12;
L5:
    ret_val = onep;
    goto L12;
L6:
    cay = abs(caysq);
    eta = onep - cay;
    eta += cay * eta;
    goto L2;
L7:
    if (caysq > onep) {
        goto L9;
    }
    eta = caysq;
    goto L3;
L8:
    *ierr = 66;
    goto L11;
L9:
    *ierr = 67;
    goto L11;
L10:
    *ierr = 65;
L11:
    ret_val = sys059;
    utsf10_c(ierr, &c__15);
L12:
    return ret_val;
} /* sf15r_c */
